/**
 * Die Klasse Ticketautomat modelliert einfache Ticketautomaten,
 * die Tickets zu einem Einheitspreis herausgeben.
 * Der Preis fr die Tickets eines Automaten kann ber den Konstruktor
 * festgelegt werden.
 * Ticketautomaten dieser Klasse prfen, ob sinnvolle Geldbetrge
 * eingeworfen werden, und drucken ein Ticket nur dann, wenn
 * ausreichend Geld eingeworfen wurde.
 *
 * @author David J. Barnes und Michael Klling
 * @version 2006.03.30
 */
public class Ticketautomat
{
    // Der Preis eines Tickets dieses Automaten.
    private int preis;
    // Der Betrag, der bisher vom Automatenbenutzer eingeworfen wurde.
    private int bisherGezahlt;
    // Die Geldsumme, die bisher von diesem Automaten eingenommen wurde.
    private int gesamtsumme;
   
    
    /**
     * Erzeuge einen Automaten, der Tickets zum angegebenen Preis
     * (in Cent) ausgibt.
     */
    public Ticketautomat(int ticketpreis)
    {
        preis = ticketpreis;
        bisherGezahlt = 0;
        gesamtsumme = 0;
    }

    /**
     * Liefere den Preis eines Tickets dieses Automaten (in Cent).
     */
    public int gibPreis()
    {
        return preis;
    }

    /**
     * Liefere die Hhe des Betrags, der fr das nchste Ticket bereits
     * eingeworfen wurde.
     */
    public int gibBisherGezahltenBetrag()
    {
        return bisherGezahlt;
    }

    /**
     * Nimm den angegebenen Betrag (in Cent) als Anzahlung fr das 
     * nchste Ticket. Prfe, ob der Betrag sinnvoll ist.
     */
    public void geldEinwerfen(int betrag)
    {
        if (betrag > 0) {
            bisherGezahlt = bisherGezahlt + betrag;
        }
        else {
            System.out.println("Bitte nur positive Betrge verwenden: "
                                + betrag);
        }
    }

    /**
     * Drucke ein Ticket, wenn gengend Geld eingeworfen wurde, und 
     * ziehe den Ticketpreis vom bisher gezahlten Betrag ab. Gib eine 
     * Fehlermeldung aus, falls noch Geld fr ein Ticket fehlt.
     */
    public void ticketDrucken()
    {
        if (bisherGezahlt >= preis) {
            // Den Ausdruck eines Tickets simulieren.
            System.out.println("##################");
            System.out.println("# Die BlueJ-Linie");
            System.out.println("# Ticket");
            System.out.println("# " + preis + " Cent.");
            System.out.println("##################");
            System.out.println();
    
            // Die Gesamtsumme um den Ticketpreis erhhen.
            gesamtsumme = gesamtsumme + preis;
            // Den Preis von der bisherigen Bezahlung abziehen.
            bisherGezahlt = bisherGezahlt - preis;
        }
        else {
            System.out.println("Sie mssen noch mindestens " +
                               (preis - bisherGezahlt) +
                               " Cent einwerfen.");
        }
    }
    
    /**
     * Gib das Wechselgeld bzw. den bisher gezahlten Betrag zurck.
     */
    public int wechselgeldAuszahlen()
    {
        int wechselgeld;
        wechselgeld = bisherGezahlt;
        bisherGezahlt = 0;
        return wechselgeld;
    }
}
